<div class="col-md-12">
    <div *ngIf="!loading">
        <div *ngIf="errorMessage" class="alert-message alert-message-danger" role="alert">
            <p>{{ errorMessage }}</p>
        </div>
    </div>
</div>
<mat-list *ngIf="!loading">
    <div>
        <div class="emptyContent" *ngIf="adminMode && visaWorkflow.items.length === 0">
            {{'lang.noVisaWorkflow' | translate}}
        </div>
        <div class="emptyContent" *ngIf="!adminMode && visaWorkflow.items.length === 0">
            {{'lang.cannotAddVisaCircuit' | translate}}
        </div>
        <mat-list-item disableRipple *ngFor="let diffusion of visaWorkflow.items;let i=index"
                       class="columns workflow"
                       [class.notEditable]="!adminMode"
                       [class.processed]="diffusion.process_date != null && (!stringIncludes(diffusion.process_comment, 'lang.hasInterruptedWorkflow' | translate) && !stringIncludes(diffusion.process_comment, 'lang.visaWorkflowInterrupted' | translate))"
                       [class.interrupt]="diffusion.process_date != null && (stringIncludes(diffusion.process_comment, 'lang.hasInterruptedWorkflow' | translate) || stringIncludes(diffusion.process_comment, 'lang.visaWorkflowInterrupted' | translate))">
            <mat-icon *ngIf="getCurrentVisaUserIndex() === i && (!adminMode || target === 'signatureBook' || target === 'action')"
                      class="fa fa-chevron-right fa-2x" mat-list-icon color="accent">
            </mat-icon>
            <mat-icon class="fa fa-2x" [class.avatar]="!functions.empty(diffusion.picture)"
                      [class.fa-user]="functions.empty(diffusion.picture) && (diffusion.isValid || (diffusion.process_date === null && diffusion.delegatedBy === null))"
                      [class.fa-user-friends]="diffusion.process_date != null && diffusion.delegatedBy !== null"
                      [class.fa-user-slash]="!diffusion.isValid"
                      [title]="!diffusion.isValid ? ('lang.userNotValid' | translate) : ''" mat-list-icon color="primary"
                      [class.invalid]="!diffusion.hasPrivilege || !diffusion.isValid"
                      [style.background-image]="!functions.empty(diffusion.picture) ? 'url('+diffusion.picture+')' : ''"
                      style="position: relative;">
                <i *ngIf="!functions.empty(diffusion.process_comment)" class="far fa-comment-dots commentBubble"
                   [matTooltip]="diffusion.process_comment"></i>
            </mat-icon>
            <ng-container *ngIf="(!adminMode || diffusion.process_date != null) && diffusion.isValid">
                <mat-icon mat-list-icon class="fa-2x fa"
                          [title]="diffusion.process_comment !== null ? diffusion.process_comment : ''"
                          [class.fa-hourglass]="diffusion.process_date == null"
                          [class.fa-thumbs-up]="diffusion.process_date != null && !stringIncludes(diffusion.process_comment, 'lang.hasInterruptedWorkflow' | translate) && !stringIncludes(diffusion.process_comment, 'lang.visaWorkflowInterrupted' | translate)"
                          [class.fa-hand-paper]="diffusion.process_date != null && stringIncludes(diffusion.process_comment, 'lang.hasInterruptedWorkflow' | translate)"
                          [class.fa-times]="diffusion.process_date != null && stringIncludes(diffusion.process_comment, 'lang.visaWorkflowInterrupted' | translate)"
                          [class.valid]="diffusion.process_date != null && !stringIncludes(diffusion.process_comment, 'lang.hasInterruptedWorkflow' | translate) && !stringIncludes(diffusion.process_comment, 'lang.visaWorkflowInterrupted' | translate)"
                          [class.invalid]="diffusion.process_date != null && (stringIncludes(diffusion.process_comment, 'lang.hasInterruptedWorkflow' | translate) || stringIncludes(diffusion.process_comment, 'lang.visaWorkflowInterrupted' | translate))"
                          style="opacity:0.5;"></mat-icon>
            </ng-container>
            <div mat-line class="workflowLine">
                <div class="workflowLineContainer">
                    <div class="workflowLineLabel" [class.unauthorized]="!diffusion.hasPrivilege || !diffusion.isValid">
                        {{diffusion.labelToDisplay}}
                        <ng-container *ngIf="diffusion.process_date != null && diffusion.delegatedBy !== null">
                            <mat-icon mat-list-icon class="fas fa-exclamation-circle"
                                      [title]="('lang.insteadOf' | translate) + ' ' + diffusion.delegatedBy"
                                      style="opacity:0.5;font-size: 125%;height: 15px;color: red;cursor: help;"></mat-icon>
                        </ng-container>
                    </div>
                    <div class="workflowLineSubLabel"
                         [class.unauthorized]="!diffusion.hasPrivilege || !diffusion.isValid">
                        {{diffusion.item_entity}}
                    </div>
                    <div class="workflowLineSubLabel"
                         *ngIf="(showComment && ((adminMode && functions.empty(diffusion.process_date)) || (getCurrentVisaUserIndex() === i && !functions.empty(diffusion.process_comment)))) && diffusion.hasPrivilege && diffusion.isValid || target === 'action'">
                        <mat-form-field>
                            <input matInput class="comment" maxlength="255"
                                   [disabled]="!adminMode || diffusion.process_date != null || (target === 'signatureBook' && getCurrentVisaUserIndex() === i)"
                                   [placeholder]="'lang.visaNote' | translate" [(ngModel)]="diffusion.process_comment" title="{{!functions.empty(diffusion.process_comment) ? diffusion.process_comment : null}}">
                        </mat-form-field>
                    </div>
                    <div *ngIf="diffusion.process_date != null && !stringIncludes(diffusion.process_comment, 'lang.visaWorkflowInterrupted' | translate) && !stringIncludes(diffusion.process_comment, 'lang.hasInterruptedWorkflow' | translate)"
                         class="workflowLineProcessDate" title='{{diffusion.process_date | fullDate}}' color="accent">
                        {{((functions.empty(diffusion.process_date) && diffusion.requested_signature) || diffusion.signatory) ? ('lang.signedUserDate' | translate) : ('lang.approvedUserDate' | translate)}} {{diffusion.process_date
                        | timeAgo : 'full'}}</div>
                    <div *ngIf="diffusion.process_date != null && stringIncludes(diffusion.process_comment, 'lang.hasInterruptedWorkflow' | translate)"
                         class="workflowLineProcessDate" title='{{diffusion.process_date | fullDate}}' color="warn">
                        {{'lang.interrupted' | translate}} {{diffusion.process_date | timeAgo : 'full'}}</div>
                </div>
                <div *ngIf="diffusion.roles.length !== 1 && diffusion.hasPrivilege && diffusion.isValid">
                    <ng-container>
                        <button mat-button [matMenuTriggerFor]="menu" class="button-form-primary">
                            <span class="menu-label">{{ selectedRoles[i] || 'Fonction' }}</span>
                            <i class="fa fa-chevron-down menu-icon"></i>
                        </button>
                        <mat-menu #menu="matMenu">
                            <ng-container *ngFor="let action of diffusion.roles ">
                                <button mat-menu-item (click)="selectRole(i, action.title)">
                                    <span style="flex: 1;">{{ action.title }}</span>
                                </button>
                            </ng-container>
                        </mat-menu>
                    </ng-container>
                </div>
                <div *ngIf="diffusion.roles.length === 1">
                    <ng-container>
                        <b style="width: 130px;height: 35px;color: var(--maarch-color-primary);padding-left: 42px;padding-right: 42px;overflow: hidden;text-overflow: ellipsis;" > {{'lang.' + diffusion.currentRole + 'User' | translate}}</b>
                    </ng-container>
                </div>
                <div *ngIf="!diffusion.hasPrivilege" class="invalid">
                    {{'lang.noPrivileges' | translate}}
                </div>
                <div *ngIf="!diffusion.isValid" class="invalid invalidMsg">
                    {{'lang.userNotValid' | translate}}
                </div>
            </div>
            <div mat-line class="workflowLine" *ngIf="getCurrentVisaUserIndex() === i && (target === 'signatureBook' || target === 'action') && diffusion.item_id !== headerService.user.id" style="color: red;font-size: 12px;padding-bottom: 5px;">
                {{'lang.signInsteadOf' | translate}}&nbsp;<b style="overflow: hidden;text-overflow: ellipsis;" [title]="diffusion.labelToDisplay">{{diffusion.labelToDisplay}}</b>
            </div>
        </mat-list-item>
    </div>
</mat-list>
<div *ngIf="loading" style="display:flex;padding: 10px;">
    <mat-spinner style="margin:auto;"></mat-spinner>
</div>
